<?php
namespace App\Notifications;

use Illuminate\Broadcasting\InteractsWithSockets;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Broadcasting\ShouldBroadcast;
use Illuminate\Notifications\Notification;
use Illuminate\Queue\SerializesModels;
use Illuminate\Foundation\Events\Dispatchable;


class MessageNotification extends Notification implements ShouldBroadcast
{
    use Dispatchable, InteractsWithSockets, SerializesModels;

    public $result;

    public function __construct($result)
    {
        $this->result = $result;
    }

    // Define the channel for a specific user
    public function broadcastOn()
    {
        // Create a private channel for the specific user
        return ['private-user.' . $this->result['receiver_id']];
    }

    public function broadcastAs()
    {
        return 'message-received';
    }

    public function toBroadcast($notifiable)
    {
        return [
            'message' => $this->result['message'],
            'sender_id' => $this->result['sender_id'],
            'receiver_id' => $this->result['receiver_id'],
        ];
    }
}
