@extends('host.layout.master')

@section('title')
    {{ __('language.chat') }}
@endsection

@section('content')

    <link rel="stylesheet" type="text/css"
          href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.min.css">

    <main class="nxl-container apps-container apps-chat">
        <div class="nxl-content without-header nxl-full-content">
            <!-- [ Main Content ] start -->
            <div class="main-content d-flex">
                <!-- [ Content Sidebar ] start -->
                <div class="content-sidebar content-sidebar-xl" data-scrollbar-target="#psScrollbarInit">
                    <div class="content-sidebar-header bg-white sticky-top hstack justify-content-between">
                        <h4 class="fw-bolder mb-0">Chat</h4>
                        <a href="javascript:void(0);" class="app-sidebar-close-trigger d-flex">
                            <i class="feather-x"></i>
                        </a>
                    </div>
                    <div class="content-sidebar-body">
                        <div class="py-0 px-4 d-flex align-items-center justify-content-between border-bottom">
                            <input type="search" class="py-3 px-0 border-0" id="chattingSearch" placeholder="Search...">
                        </div>
                        <div class="content-sidebar-items" id="chatUsersList"></div>
                    </div>
                </div>
                <!-- [ Content Sidebar  ] end -->
                @if(isset($user))
                    <div class="content-area" data-scrollbar-target="#psScrollbarInit">
                        <div class="content-area-header sticky-top">
                            <div class="page-header-left hstack gap-4">
                                <a href="javascript:void(0);" class="app-sidebar-open-trigger">
                                    <i class="feather-align-left fs-20"></i>
                                </a>
                                <a href="javascript:void(0);"
                                   class="d-flex align-items-center justify-content-center gap-3"
                                   data-bs-toggle="offcanvas" data-bs-target="#userProfileDetails">
                                    <div class="avatar-image">
                                        <img src="{{ URL::asset('/admin/assets/uploads/'.$user->image) }}"
                                             class="img-fluid"
                                             alt="image">
                                    </div>
                                    <div class="d-none d-sm-block">
                                        <div
                                            class="fw-bold d-flex align-items-center">{{ ($user->name) ? $user->name : '' }}</div>
                                    </div>
                                </a>
                            </div>
                        </div>
                        <div class="content-area-body" id="chatMessageContainer"
                             style="min-height: 470px;max-height: 470px;overflow: scroll">

                        </div>
                        <!--! BEGIN: Message Editor !-->
                        <form id="chatForm">
                            <div
                                class="d-flex align-items-center justify-content-between border-top border-gray-5 bg-white sticky-bottom">
                                <input class="form-control border-0 emoji-picker1"
                                       placeholder="Type your message here..." required id="chat_message"
                                       name="chat_message">
                                <input type="hidden" name="receiverid" id="receiverid" value="{{ $user->id }}">
                                <div class="border-start border-gray-5 send-message">
                                    <button type="submit" id="sendMessageButton"
                                            class="wd-60 d-flex align-items-center justify-content-center"
                                            style="height: 59px;cursor:pointer;background-color: transparent;border: none">
                                        <i class="feather-send"></i></button>
                                </div>
                            </div>
                        </form>
                    </div>
                @else
                    <div class="content-area">
                        <div class="row text-center">
                            <div class="col-md-4"></div>
                            <div class="col-md-4">
                                <h3 class="mt-5"><b>Select user first...</b></h3>
                            </div>
                            <div class="col-md-4"></div>
                        </div>
                    </div>
                @endif

            </div>
            <!-- [ Main Content ] end -->
        </div>
    </main>

@endsection
@section('script')

    <script src="https://cdnjs.cloudflare.com/ajax/libs/pusher/7.0.3/pusher.min.js"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
    <script>
        // Initialize Pusher
        var pusher = new Pusher('94241e12d2f1cc6bcdea', {
            cluster: 'ap2',
            encrypted: true
        });

        // Subscribe to the 'user-messages' channel
        var myid = '{{ Auth::guard('host')->user()->id }}';


        var channel = pusher.subscribe('user-messages-' + myid);

        // Bind to the 'admin-message' event
        channel.bind('user-message-' + myid, function (data) {
            fetchMessages();
        });
    </script>

    <script>

        @if(isset($user))
        fetchMessages();
        @endif

        loadChatUsers();

        toastr.options = {
            'closeButton': true,
            'debug': false,
            'newestOnTop': false,
            'progressBar': false,
            'positionClass': 'toast-top-right',
            'preventDuplicates': false,
            'showDuration': '1000',
            'hideDuration': '1000',
            'timeOut': '5000',
            'extendedTimeOut': '1000',
            'showEasing': 'swing',
            'hideEasing': 'linear',
            'showMethod': 'fadeIn',
            'hideMethod': 'fadeOut',
        }

        $(".chat-list a").click(function () {
            $(".chatbox").addClass('showbox');
            return false;
        });

        $(".chat-icon").click(function () {
            $(".chatbox").removeClass('showbox');
        });

        toastr.options = {
            'closeButton': true,
            'debug': false,
            'newestOnTop': false,
            'progressBar': false,
            'positionClass': 'toast-top-right',
            'preventDuplicates': false,
            'showDuration': '1000',
            'hideDuration': '1000',
            'timeOut': '5000',
            'extendedTimeOut': '1000',
            'showEasing': 'swing',
            'hideEasing': 'linear',
            'showMethod': 'fadeIn',
            'hideMethod': 'fadeOut',
        }

        $('#chatForm').submit(function (e) {
            e.preventDefault(); // Prevent default form submission

            var mymessage = $('#chat_message').val();
            var receiver_id = $('#receiverid').val();

            if (mymessage == "") {
                toastr.error("Message Required.");
                return false;
            }

            // Collect form data
            var formData = {
                'message': mymessage,
                "receiver_id": receiver_id
            };

            // Retrieve CSRF token value from meta tag
            var csrfToken = $('meta[name="csrf-token"]').attr('content');

            // Include CSRF token in AJAX request headers
            $.ajaxSetup({
                headers: {
                    'X-CSRF-TOKEN': csrfToken
                }
            });

            // Send AJAX request
            $.ajax({
                type: 'POST',
                url: '{{ route("host.send_message_from_host") }}', // Replace 'your_route_name' with your actual route name
                data: formData,
                dataType: 'json',
                encode: true,
                beforeSend: function () {
                    $('#sendMessageButton').attr('disabled', true);
                },
                success: function (response) {
                    if (response.success) {
                        toastr.success('Message Send.');
                        fetchMessages();
                    } else {
                        toastr.error(response.message, "Error");
                    }
                },
                error: function (xhr) {
                    console.error('Error:', xhr.responseJSON.message);
                    toastr.error('Failed to send message', "Error");
                },
                complete: function () {
                    $('#sendMessageButton').attr('disabled', false);
                }
            });
            $('#chat_message').val("");
        });

        function fetchMessages() {
            // Fetch messages
            var receiver_id = $('#receiverid').val();

            $.ajax({
                url: '{{ route('host.fetchhostMessages') }}',
                method: 'GET',
                data: {
                    receiver_id: receiver_id
                },
                success: function (data) {

                    $('#chatMessageContainer').empty();

                    loadChatUsers();

                    var messagesHtml = '';

                    $.each(data, function (index, message) {

                        var sender_name = message.sender ? message.sender.name : 'Unknown User';

                        var image_name = message.sender.image;

                        var time = formatDate(message.created_at);

                        if (message.sender_id == {{ Auth::guard('host')->user()->id }}) {

                            messagesHtml += ` <div class="single-chat-item">
                                <div class="d-flex align-items-center gap-3 mb-3">
                                    <a href="javascript:void(0)" class="avatar-image">
                                        <img src="${'{{ URL::asset("admin/assets/uploads/") }}'}/${image_name}"
                                             class="img-fluid rounded-circle"
                                             alt="image">
                                    </a>
                                    <div class="d-flex align-items-center gap-2">
                                        <a>` + sender_name + `</a>
                                        <span class="wd-5 ht-5 bg-gray-400 rounded-circle"></span>
                                        <span class="fs-11 text-muted">` + time + `</span>
                                    </div>
                                </div>
                                <div class="wd-500 p-3 rounded-5 bg-gray-200">
                                    <p class="py-2 px-3 rounded-5 bg-white">` + message.message + `</p>
                                </div>
                            </div>`;

                        } else {

                            messagesHtml += `<div class="single-chat-item">
                                <div class="d-flex flex-row-reverse align-items-center gap-3 mb-3">
                                    <a href="javascript:void(0)" class="avatar-image">
                                        <img src="${'{{ URL::asset("admin/assets/uploads/") }}'}/${image_name}"
                                             class="img-fluid rounded-circle"
                                             alt="image">
                                    </a>
                                    <div class="d-flex flex-row-reverse align-items-center gap-2">
                                        <a>` + sender_name + `</a>
                                        <span class="wd-5 ht-5 bg-gray-400 rounded-circle"></span>
                                        <span class="fs-11 text-muted">` + time + `</span>
                                    </div>
                                </div>
                                <div class="wd-500 p-3 rounded-5 bg-gray-200 ms-auto">
                                    <p class="py-2 px-3 rounded-5 bg-white">` + message.message + `</p>
                                </div>
                            </div>`;

                        }
                    });

                    $('#chatMessageContainer').html(messagesHtml);
                    scrollToBottom();

                },
                error: function (xhr, status, error) {
                    console.error('Error fetching messages:', error);
                }
            });
            scrollToBottom();
        }

        function formatDate(date) {
            var d = new Date(date);

            // Get day, month, year, hours, and minutes
            var day = d.getDate();
            var month = d.toLocaleString('default', {month: 'short'}); // Get abbreviated month name
            var year = d.getFullYear();
            var hours = d.getHours();
            var minutes = d.getMinutes();

            // Convert hours to 12-hour format
            var ampm = hours >= 12 ? 'pm' : 'am';
            hours = hours % 12;
            hours = hours ? hours : 12; // Handle midnight (12:00 am)

            // Add leading zeros to minutes if needed
            minutes = minutes < 10 ? '0' + minutes : minutes;

            // Construct formatted string
            var formattedDate = day + ' ' + month + ' ' + year + ' ' + hours + ':' + minutes + ' ' + ampm;

            return formattedDate;
        }

        function scrollToBottom() {
            const chatContainer = document.getElementById('chatMessageContainer');
            if (chatContainer) {
                chatContainer.scrollTop = chatContainer.scrollHeight;
            }
        }

        function loadChatUsers() {
            $.ajax({
                url: '{{ route('host.loadChatUsersforhost') }}',
                method: 'GET',
                success: function (data) {
                    $('#chatUsersList').empty(); // Clear the current list
                    var usersHtml = '';

                    $.each(data, function (index, user) {
                        usersHtml += `
                             <div class="p-4 d-flex position-relative border-bottom c-pointer single-item">
                                <img class="img-fluid"
                                                                 src="${user.image ? '/admin/assets/uploads/' + user.image : 'https://mehedihtml.com/chatbox/assets/img/user.png'}" style='width:40px;height:40px;border-radius: 50%'
                                                                 alt="user img">
                                <div class="ms-3 item-desc">
                                    <div class="w-100 d-flex align-items-center justify-content-between">
                                        <a href="/host/Host+Chat/${user.id}" class="hstack gap-2 me-2">
                                            <span>${user.name} ${user.unseen > 0 ? `<b>(<span>${user.unseen}</span>)</b>` : ''}</span>
<!--                                            <div class="wd-5 ht-5 rounded-circle opacity-75 me-1 bg-danger"></div>-->
<!--                                            <span class="fs-10 fw-medium text-muted text-uppercase d-none d-sm-block">5 min ago</span>-->
                                        </a>
                                    </div>
                                    <p class="fs-12 fw-semibold text-dark mt-2 mb-0 text-truncate-2-line">
                                        ${user.country ? `(${user.country})` : ''}
                                    </p>
                                </div>
                            </div>`;
                    });

                    $('#chatUsersList').html(usersHtml); // Populate with chat users
                },
                error: function (xhr, status, error) {
                    console.error('Error fetching chat users:', error);
                }
            });
        }

    </script>
@endsection
